package tis4.auth.client;

import java.io.IOException;
import java.io.StringReader;
import java.util.Scanner;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

import tis4.auth.client.XMLHandler;

public class ClientListener implements Runnable{
	private static final int SLEEP_TIME = 10; //ms
	private boolean run = true;
	private Scanner input;
	private SAXParser saxParser;
	private XMLHandler xmlHandler;
	private ClientMain clientMain;
	public ClientListener(ClientMain clientMain){
		this.input = clientMain.getInput();;
		this.clientMain = clientMain;
		SAXParserFactory factory = SAXParserFactory.newInstance();
		try {
			saxParser = factory.newSAXParser();
		} catch (ParserConfigurationException e) {
			System.err.println("Could not setup xml parser");
		} catch (SAXException e) {
			System.err.println("Could not setup xml parser");
		}
		xmlHandler = new XMLHandler(this.clientMain);
		System.out.println("Listener setup");
	}
	public void stop(){
		run = false;
	}
	@Override
	public void run() {
		System.out.println("Listener Running");
		while(run){
			while(input.hasNextLine()){
				String line = input.nextLine();
				processLine(line);
				Thread.yield();
			}
			
			try {
				Thread.sleep(SLEEP_TIME);
			} catch (InterruptedException e) {
				System.err.println("listener thread could not sleep");
			}
		}
	}
	private void processLine(String line){
		line = line.trim();
		try {
			saxParser.parse(new InputSource(new StringReader(line)),xmlHandler);
			xmlHandler.passOn();
		} catch (SAXException e) {
			System.err.println("Could not parse XML");
		} catch (IOException e) {
			System.err.println("Could not parse XML");
		}
	}
}
