package tis4.auth.client.gui;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTextField;

import tis4.auth.client.ClientMain;

public class LoginScreen extends JFrame implements ActionListener{
	private static final long serialVersionUID = 1L;
	private ClientMain clientMain;
	private JTextField username, password;
	public LoginScreen(ClientMain clientMain){
		this.setTitle("Login Screen");
		this.clientMain = clientMain;
		JPanel mainPanel = new JPanel();
		this.add(mainPanel,BorderLayout.CENTER);
		username = new JTextField(12);
		password = new JTextField(12);
		mainPanel.add(username);
		mainPanel.add(password);
		JButton login = new JButton("Login");
		login.addActionListener(this);
		mainPanel.add(login);
		//init other components
		//set a closing event
		this.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		this.addWindowListener(new java.awt.event.WindowAdapter() {
		    @Override
		    public void windowClosing(java.awt.event.WindowEvent windowEvent) {
		        exit();
		    }
		});
		this.pack();
		this.setVisible(true);
		
	}
	@Override
	public void actionPerformed(ActionEvent arg0) {
		if(arg0.getActionCommand().equals("Login")){
			this.setTitle("Logging in...");
			try {
				clientMain.connect();
			} catch (IOException e) {
				System.err.println("Could not connect to server");
			}
			clientMain.login(username.getText(), password.getText());
		}
	}
	public void setLoggedIn(boolean l){
		if(l){
			this.setTitle("Logged In");
			clientMain.setMainScreen(new MainScreen(clientMain));
			this.dispose();
		}else{
			this.setTitle("Login Failure");
		}
	}
	public void exit(){
		clientMain.exit();
	}
}
