package tis4.auth.client.valueparser;

import java.util.ArrayList;

import tis4.auth.client.ClientMain;
import tis4.auth.client.XMLElement;
import tis4.auth.client.gui.MainScreen;
import tis4.auth.client.valueparser.ValueParser;

public class Admin implements ValueParser{
	private static final String TAG = "admin";
	private ClientMain clientSocket;
	private ArrayList<XMLElement> valueList = null;
	public Admin(ClientMain clientSocket){
		this.clientSocket = clientSocket;
	}
	@Override
	public void parse(ArrayList<XMLElement> nameValuePairList) {
		valueList = nameValuePairList;
		for(XMLElement n: valueList){
			if(n.getValue()!=null){
				if("command".equalsIgnoreCase(n.getName())){
					processCommand(n.getValue());
				}else if("info".equalsIgnoreCase(n.getName())){
					processInfo(n.getValue());
				}
			}
		}
	}
	private void processCommand(String command){
		if("disconnect".equals(command)){
			clientSocket.close();
		}
	}
	private void processInfo(String info){
		if("ping".equalsIgnoreCase(info)){
			clientSocket.getOutput().println("<admin><info>pong</info></admin>");
		}else if("pong".equalsIgnoreCase(info)){
			MainScreen m = clientSocket.getMainScreen();
			if(m!=null){
				m.pong();
			}
		}
	}
	@Override
	public String getTag() {
		return TAG;
	}

}

