package tis4.auth.client.valueparser;

import java.util.ArrayList;

import tis4.auth.client.ClientMain;
import tis4.auth.client.TagType;
import tis4.auth.client.XMLElement;

public class Login implements ValueParser{
	private static final String TAG = "login";
	private ClientMain clientSocket;
	private ArrayList<XMLElement> valueList = null;
	public Login(ClientMain clientSocket){
		this.clientSocket = clientSocket;
	}
	public String getTag(){
		return TAG;
	}
	/**
	 * Extracts the user and pass checks authentication and upon error disconnects client
	 */
	@Override
	public void parse(ArrayList<XMLElement> nameValuePairList) {
		valueList = nameValuePairList;
		for(XMLElement e: valueList){
			processElement(e);
		}
	}
	private void processElement(XMLElement e){
		if(e.getType()==TagType.FULL){
			if(e.getName().equals("info")){
				if(e.getValue().equals("login success")){
					clientSocket.getLoginScreen().setLoggedIn(true);
				}
			}else if(e.getName().equals("error")){
				clientSocket.getLoginScreen().setLoggedIn(false);
			}
		}
	}
}
