package tis4.auth.server;

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.ArrayList;

public class ServerMain {
	private ServerSocket serverSocket;
	private boolean run = true;
	private ArrayList<ClientSocket> clientList;
	public static void main(String[] args) {
		new ServerMain();

	}
	/**
	 * sets up a socket server and begins listening loop
	 */
	public ServerMain(){
		try {
		    serverSocket = new ServerSocket(4444);
		} 
		catch (IOException e) {
		    System.out.println("Could not listen");
		    System.exit(-1);
		}
		clientList = new ArrayList<ClientSocket>();
		System.out.println("Server started");
		System.out.println("Listening...");
		while(run){
			//blocks until a client connects then passes it to it's own thread in a handler
			try {
				Socket clientSocket = serverSocket.accept();
				ClientSocket h = new ClientSocket(clientSocket, this);
				clientList.add(h);
				(new Thread(h)).run();
			} catch (IOException e) {
				System.err.println("Could not pass client socket to handler");
				e.printStackTrace();
			}
		}
	}
	/**
	 * disconnects all clients and stops the server safely
	 */
	public void stop(){
		System.out.println("Stopping");
		for(ClientSocket h: clientList){
			run = false;
			h.close();
		}
		try {
			serverSocket.close();
		} catch (IOException e) {
			System.err.println("Couldn't close server socket, quitting anyway");
		}
		System.exit(0);
	}
	public synchronized void removeClient(ClientSocket h){
		if(clientList.contains(h)) { clientList.remove(h); }
	}
	/**
	 * This method would connect to a database and check client credentials
	 */
	public synchronized boolean authenticate(String user, String pass){
		if("admin".equals(user)&&"admin".equals(pass)){
			return true;
		}else{
			return false;
		}
	}

}
