package tis4.auth.server.valueparser;

import java.util.ArrayList;

import tis4.auth.server.ClientSocket;
import tis4.auth.server.XMLElement;
/**
 * General command/info class that handles incomming <admin>
 * @author tim
 *
 */
public class Admin implements ValueParser{
	private static final String TAG = "admin";
	private ClientSocket clientSocket;
	private ArrayList<XMLElement> valueList = null;
	public Admin(ClientSocket clientSocket){
		this.clientSocket = clientSocket;
	}
	@Override
	public void parse(ArrayList<XMLElement> nameValuePairList) {
		valueList = nameValuePairList;
		for(XMLElement n: valueList){
			if(n.getValue()!=null){
				if("command".equalsIgnoreCase(n.getName())){
					processCommand(n.getValue());
				}else if("info".equalsIgnoreCase(n.getName())){
					processInfo(n.getValue());
				}
			}
		}
	}
	private void processCommand(String command){
		if("disconnect".equals(command)){
			clientSocket.getWriter().println("<admin><info>closing socket</info><admin>");
			clientSocket.close();
		}
	}
	private void processInfo(String info){
		if("ping".equalsIgnoreCase(info)){
			clientSocket.getWriter().println("<admin><info>pong</info></admin>");
		}
	}
	@Override
	public String getTag() {
		return TAG;
	}

}
