package tis4.auth.server.valueparser;

import java.util.ArrayList;

import tis4.auth.server.ClientSocket;
import tis4.auth.server.XMLElement;

public class Login implements ValueParser{
	private static final String TAG = "login";
	private ClientSocket clientSocket;
	private String user, pass;
	private ArrayList<XMLElement> valueList = null;
	public Login(ClientSocket clientSocket){
		this.clientSocket = clientSocket;
	}
	public String getTag(){
		return TAG;
	}
	/**
	 * Extracts the user and pass checks authentication and upon error disconnects client
	 */
	@Override
	public void parse(ArrayList<XMLElement> nameValuePairList) {
		valueList = nameValuePairList;
		user = getValueByName("user");
		pass = getValueByName("pass");
		if(user!=null&&pass!=null){
			clientSocket.authenticate(user, pass);
		}else{
			clientSocket.getWriter().println("<login><error>error processing user or pass</error></login>");
			clientSocket.close();
		}
	}
	/**
	 * 
	 * @param name
	 * @return the value associated with the name given or null if that name is not found
	 */
	private String getValueByName(String name){
		for(XMLElement n: valueList){
			if(n.getName().equals(name)){
				return n.getValue();
			}
		}
		return null;
	}

}
